## libfreenect 0.5.2+git6

=== CMakeLists.txt ===
######################################################################################
# License
######################################################################################

# This file is part of the OpenKinect Project. http://www.openkinect.org
#
# Copyright (c) 2010 individual OpenKinect contributors. See the CONTRIB file
# for details.
#
# This code is licensed to you under the terms of the Apache License, version
# 2.0, or, at your option, the terms of the GNU General Public License,
# version 2.0. See the APACHE20 and GPL2 files for the text of the licenses,
# or the following URLs:
# http://www.apache.org/licenses/LICENSE-2.0
# http://www.gnu.org/licenses/gpl-2.0.txt
#
# If you redistribute this file in source form, modified or unmodified, you
# may:
#   1) Leave this header intact and distribute it under the same terms,
#      accompanying it with the APACHE20 and GPL20 files, or
#   2) Delete the Apache 2.0 clause and accompany it with the GPL2 file, or
#   3) Delete the GPL v2 clause and accompany it with the APACHE20 file
# In all cases you must keep the copyright notice intact and include a copy
# of the CONTRIB file.
#
# Binary distributions must follow the binary distribution requirements of
# either License.

######################################################################################
# CMake directives
######################################################################################

cmake_minimum_required(VERSION 2.6)
set(PYTHON_EXECUTABLE "python2")

######################################################################################
# Project declaration and options
######################################################################################

PROJECT(libfreenect)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/")

# Find the host operating system and architecture
include (FindOS)
# Set up installation directories
include (SetupDirectories)

set (PROJECT_VER_MAJOR 0)
set (PROJECT_VER_MINOR 5)
set (PROJECT_VER_PATCH 2)
set (PROJECT_VER
  "${PROJECT_VER_MAJOR}.${PROJECT_VER_MINOR}.${PROJECT_VER_PATCH}")
set (PROJECT_APIVER
  "${PROJECT_VER_MAJOR}.${PROJECT_VER_MINOR}")

OPTION(BUILD_REDIST_PACKAGE "Build libfreenect in a legally-redistributable manner (only affects audio)" ON)
OPTION(BUILD_EXAMPLES "Build example programs" ON)
OPTION(BUILD_FAKENECT "Build fakenect mock library" ON)
OPTION(BUILD_C_SYNC "Build c synchronous library" ON)
OPTION(BUILD_CPP "Build C++ Library (currently header only)" ON)
OPTION(BUILD_CV "Build OpenCV wrapper" OFF)
OPTION(BUILD_AS3_SERVER "Build the Actionscript 3 Server Example" OFF)
OPTION(BUILD_PYTHON "Build Python extension" OFF)
OPTION(BUILD_OPENNI2_DRIVER "Build libfreenect driver for OpenNI2" OFF)
IF(PROJECT_OS_LINUX)
	OPTION(BUILD_CPACK_DEB "Build an DEB using CPack" OFF)
	OPTION(BUILD_CPACK_RPM "Build an RPM using CPack" OFF)
	OPTION(BUILD_CPACK_TGZ "Build an TGZ using CPack" OFF)
ENDIF(PROJECT_OS_LINUX)

######################################################################################
# Dependencies and Definitions
######################################################################################

# Find packages needed to build library
find_package(libusb-1.0 REQUIRED)

# Check the endianness of the system
include (TestBigEndian)
test_big_endian(BIG_ENDIAN)
if(BIG_ENDIAN)
  add_definitions(-DFN_BIGENDIAN)
endif()

if (WIN32)
  set(MATH_LIB "")
else(WIN32)
  set(MATH_LIB "m")
endif()

######################################################################################
# CMake
######################################################################################

SET(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
SET(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)
SET(DOC_OUTPUT_PATH ${CMAKE_BINARY_DIR}/doc)

if    (MSVC)
  set(C_FLAGS_WARNING "-W4")
else  ()
  set(C_FLAGS_WARNING "-Wall")
endif (MSVC)

set(C_CXX_FLAGS_DEFAULT "${C_FLAGS_WARNING} -O2")

# These defaults can be overriden by -DCMAKE_C_FLAGS=""
set(CMAKE_C_FLAGS "${C_CXX_FLAGS_DEFAULT} ${CMAKE_C_FLAGS}")
# C Configurations
SET(CMAKE_C_FLAGS_DEBUG   "${CMAKE_C_FLAGS} -O0 -g -DDEBUG=1")
SET(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS}")
SET(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELEASE} -g")

# These defaults can be overriden by -DCMAKE_CXX_FLAGS=""
set(CMAKE_CXX_FLAGS "${C_CXX_FLAGS_DEFAULT} ${CMAKE_CXX_FLAGS}")
# C++ Configurations
SET(CMAKE_CXX_FLAGS_DEBUG   "${CMAKE_CXX_FLAGS} -O0 -g -DDEBUG=1")
SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS}")
SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELEASE} -g")

# Pretty much everyone is going to need the main includes
include_directories (${CMAKE_CURRENT_SOURCE_DIR}/include)

# libfreenect.h includes libusb.h, so everyone needs this too
include_directories(${LIBUSB_1_INCLUDE_DIRS})

if(WIN32)
  include_directories("${CMAKE_CURRENT_SOURCE_DIR}/platform/windows")
endif()

# Add library project
add_subdirectory (src)

IF(BUILD_EXAMPLES)
  add_subdirectory (examples)
ENDIF()

IF(BUILD_FAKENECT)
  add_subdirectory (fakenect)
ENDIF()

IF(BUILD_C_SYNC)
  add_subdirectory (wrappers/c_sync)
ENDIF()

IF(BUILD_CPP)
  add_subdirectory (wrappers/cpp)
ENDIF()

IF(BUILD_CV)
  add_subdirectory (wrappers/opencv)
ENDIF()

IF(BUILD_AS3_SERVER)
  add_subdirectory(wrappers/actionscript)
ENDIF()

IF(BUILD_PYTHON)
  add_subdirectory (wrappers/python)
ENDIF()

IF(BUILD_OPENNI2_DRIVER)
  add_subdirectory(OpenNI2-FreenectDriver)
ENDIF()

######################################################################################
# Extras
######################################################################################

# Create an uninstall target
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/UninstallTarget.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/UninstallTarget.cmake"
  IMMEDIATE @ONLY)

# --- cmake config file ---
CONFIGURE_FILE(libfreenectConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/libfreenectConfig.cmake @ONLY)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libfreenectConfig.cmake DESTINATION share/${PROJECT_NAME})

add_custom_target(uninstall
  COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/UninstallTarget.cmake)

# Create Debian/RPM Packages
# after make, use "fakeroot cpack" in the build Dir to complete

IF ( BUILD_CPACK_TGZ OR BUILD_CPACK_DEB OR BUILD_CPACK_RPM )
  set(CPACK_PACKAGE_DESCRIPTION "libfreenect for kinect")
  set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "libfreenect library for using kinect")
  set(CPACK_PACKAGE_NAME "libfreenect-dev")
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "libusb-1.0-0-dev")

  set(CPACK_PACKAGE_CONTACT "OpenKinect <openkinect@googlegroups.com>")
  #set(CPACK_PACKAGE_VENDOR "")
  set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VER_MAJOR})
  set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VER_MINOR})
  set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VER_PATCH})
  set(VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

  set(CPACK_GENERATOR "")
  if (BUILD_CPACK_TGZ)
    list(APPEND CPACK_GENERATOR "TGZ")
  endif()
  if (BUILD_CPACK_RPM)
    list(APPEND CPACK_GENERATOR "RPM")
  endif()
  if (BUILD_CPACK_DEB)
    list(APPEND CPACK_GENERATOR "DEB")
  endif()
  set(CPACK_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}-${CMAKE_SYSTEM_PROCESSOR}")

  include(CPack)

  INSTALL(FILES "${CMAKE_BINARY_DIR}/lib/libfreenect.a" DESTINATION ${PROJECT_LIBRARY_INSTALL_DIR})
  INSTALL(FILES "include/libfreenect.h" DESTINATION ${PROJECT_INCLUDE_INSTALL_DIR})
  INSTALL(FILES "include/libfreenect_registration.h" DESTINATION ${PROJECT_INCLUDE_INSTALL_DIR})
  INSTALL(FILES "include/libfreenect_audio.h" DESTINATION ${PROJECT_INCLUDE_INSTALL_DIR})
  INSTALL(FILES "APACHE20" DESTINATION "share/doc/${CPACK_PACKAGE_NAME}")
  INSTALL(FILES "GPL2" DESTINATION "share/doc/${CPACK_PACKAGE_NAME}")
  INSTALL(FILES "README.md" DESTINATION "share/doc/${CPACK_PACKAGE_NAME}")

ENDIF ( )

## libfreenect 0.5.2+git6-g5455843+dfsg

=== debian/changelog ===
libfreenect (1:0.5.2+git6-g5455843+dfsg-1) unstable; urgency=medium

  * New upstream snapshot from v0.5.2-6-g5455843 with few fixes
  * Upload to unstable
  * Added 3 new missing symbols to .symbols file
  * debian/control
    - boosted policy compliance to 3.9.6

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 29 Apr 2015 09:15:43 -0400

libfreenect (1:0.5.2+git2-g68073c3+dfsg-1) experimental; urgency=medium

  * New upstream snapshot from v0.5.2-2-g68073c3
  * debian/patches/add-missing-libs.patch to resolve conflict
  * debian/control
    - requires libusb >= 1.0.18 (for libusb_get_parent)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 13 Feb 2015 10:22:27 -0500

libfreenect (1:0.5.1+dfsg-1) experimental; urgency=medium

  * The latest upstream release
  * debian/patches
    - some removed, some refreshed
    - adjusted for which python gets selected (force to use python 2)
  * debian/libfreenect0.5.symbols
    - updated for introduced new symbols
  * debian/rules
    - no longer manual prefixing of binaries is needed, upstream provides
      prefixes
  * debian/control
    - -dev package depends on libusb-1.0-0-dev (Closes: #775768)
  * debian/copyright
    - updated upstream years and added missing copyright/license information
      (Thanks Thorsten Alteholz for the review)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 20 Jan 2015 14:00:33 -0500

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_LDFLAGS_MAINT_APPEND=-Wl,-Bsymbolic-functions -Wl,--as-needed
export MA_TRIPLET=`dpkg-architecture -qDEB_HOST_MULTIARCH`

%:
	dh $@ --with python2

override_dh_auto_configure:
	dh_auto_configure -- \
      -DBUILD_PYTHON:Bool=True -DPYTHON_EXECUTABLE=python -DPROJECT_LIBRARY_INSTALL_DIR:Path="lib/$(MA_TRIPLET)"

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	doxygen debian/doxygen.conf
else
	: # Documentation was not built due to nodoc flag in DEB_BUILD_OPTIONS
	: # Creating dummy blank debian/html expected by -doc package
	mkdir -p debian/html
endif

override_dh_python2:
	dh_python2 -p python-freenect
	if [ -x /usr/bin/dh_numpy ]; then dh_numpy -ppython-freenect; fi

override_dh_installdocs:
	dh_installdocs --all CONTRIB

override_dh_makeshlibs:
	dh_makeshlibs -Xfakenect

override_dh_clean-indep:
	rm -rf debian/html

## libfreenect 0.5.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -48,7 +48,7 @@
 
 set (PROJECT_VER_MAJOR 0)
 set (PROJECT_VER_MINOR 5)
-set (PROJECT_VER_PATCH 2)
+set (PROJECT_VER_PATCH 3)
 set (PROJECT_VER
   "${PROJECT_VER_MAJOR}.${PROJECT_VER_MINOR}.${PROJECT_VER_PATCH}")
 set (PROJECT_APIVER

=== OpenNI2-FreenectDriver/CMakeLists.txt ===
######################################################################################
# OpenNI2-FreenectDriver
######################################################################################

file(GLOB HEADERS src/*.hpp src/*.h)
file(GLOB SOURCES src/*.cpp)
add_library(FreenectDriver SHARED ${HEADERS} ${SOURCES})

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-function")

set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib/OpenNI2-FreenectDriver)
set_target_properties(FreenectDriver PROPERTIES
  VERSION ${PROJECT_VER}
  SOVERSION ${PROJECT_APIVER}
  OUTPUT_NAME FreenectDriver)
  
add_definitions(-DPROJECT_VER="${PROJECT_VER}")

include_directories(extern/OpenNI-Linux-x64-2.2.0.33/Include)
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/wrappers/cpp)

target_link_libraries(FreenectDriver freenectstatic ${MATH_LIB})

install (TARGETS FreenectDriver
  DESTINATION "${PROJECT_LIBRARY_INSTALL_DIR}/OpenNI2-FreenectDriver")

=== examples/CMakeLists.txt ===
######################################################################################
# Packages needed for examples
######################################################################################

# These examples have no external dependencies and should always build.
add_executable(freenect-camtest camtest.c)
add_executable(freenect-wavrecord wavrecord.c)
target_link_libraries(freenect-camtest freenect)
target_link_libraries(freenect-wavrecord freenect)
install(TARGETS freenect-camtest freenect-wavrecord
        DESTINATION bin)

# All viewers need pthreads and GLUT.
set(THREADS_USE_PTHREADS_WIN32 true)
find_package(Threads)
find_package(OpenGL)
find_package(GLUT)

if (Threads_FOUND AND OPENGL_FOUND AND GLUT_FOUND)
  include_directories(${THREADS_PTHREADS_INCLUDE_DIR} ${OPENGL_INCLUDE_DIR} ${GLUT_INCLUDE_DIR})

  add_executable(freenect-glview glview.c)
  add_executable(freenect-regview regview.c)
  add_executable(freenect-hiview hiview.c)
  add_executable(freenect-chunkview chunkview.c)
  add_executable(freenect-micview micview.c)

  target_link_libraries(freenect-glview freenect ${OPENGL_LIBRARIES} ${GLUT_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIB})
  target_link_libraries(freenect-regview freenect ${OPENGL_LIBRARIES} ${GLUT_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIB})
  target_link_libraries(freenect-hiview freenect ${OPENGL_LIBRARIES} ${GLUT_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIB})
  target_link_libraries(freenect-chunkview freenect ${OPENGL_LIBRARIES} ${GLUT_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIB})
  target_link_libraries(freenect-micview freenect ${OPENGL_LIBRARIES} ${GLUT_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIB})

  install(TARGETS freenect-glview freenect-regview freenect-hiview freenect-chunkview freenect-micview
          DESTINATION bin)
endif ()

# A few examples use c_sync.
if (BUILD_C_SYNC)
  find_package(Threads REQUIRED)
  include_directories(../wrappers/c_sync/)
  include_directories(${THREADS_PTHREADS_INCLUDE_DIR} ${OPENGL_INCLUDE_DIR} ${GLUT_INCLUDE_DIR})

  add_executable(freenect-regtest regtest.c)
  add_executable(freenect-tiltdemo tiltdemo.c)

  target_link_libraries(freenect-regtest freenect_sync ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIB})
  target_link_libraries(freenect-tiltdemo freenect_sync ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIB})

  install(TARGETS freenect-regtest freenect-tiltdemo
          DESTINATION bin)

  if (OPENGL_FOUND AND GLUT_FOUND)
    add_executable(freenect-glpclview glpclview.c)
    target_link_libraries(freenect-glpclview freenect_sync ${OPENGL_LIBRARIES} ${GLUT_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIB})
    install(TARGETS freenect-glpclview
            DESTINATION bin)
  endif ()
endif ()

=== fakenect/CMakeLists.txt ===
######################################################################################
# Fakenect Mock Library
######################################################################################
SET(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
SET(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib/fakenect)
add_library (fakenect SHARED fakenect.c)
set_target_properties ( fakenect PROPERTIES
  VERSION ${PROJECT_VER}
  SOVERSION ${PROJECT_APIVER}
  OUTPUT_NAME freenect)
target_link_libraries(fakenect ${MATH_LIB})

install (TARGETS fakenect
  DESTINATION "${PROJECT_LIBRARY_INSTALL_DIR}/fakenect")

add_executable(fakenect-record record.c)
target_link_libraries(fakenect-record freenect ${MATH_LIB})
install (TARGETS fakenect-record
  DESTINATION bin)

CONFIGURE_FILE("fakenect.sh.in"
  "fakenect.sh"
  IMMEDIATE @ONLY)
install (PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/fakenect.sh
  DESTINATION bin
  RENAME fakenect)

install(FILES fakenect.1 fakenect-record.1
  DESTINATION ${PROJECT_MANPAGE_INSTALL_DIR}/man1)

=== src/CMakeLists.txt ===
######################################################################################
# Build for main library
######################################################################################

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${LIBUSB_1_INCLUDE_DIRS})

# Audio Firmware
include(FindPythonInterp)
IF(BUILD_REDIST_PACKAGE)
  # If this build is intended for a redistributable package, we can't include audios.bin, so we should include fwfetcher.py
  # and the package should run "python fwfetcher.py $INSTALL_PREFIX/share" as a postinst hook
  install (FILES "fwfetcher.py" DESTINATION "${CMAKE_INSTALL_PREFIX}/share")
ELSE(BUILD_REDIST_PACKAGE)
  # If the install is local only, we can just run fwfetcher.py and install the audios.bin firmware to the system folder
  add_custom_target(firmware ALL
      COMMAND ${PYTHON_EXECUTABLE} "${CMAKE_CURRENT_SOURCE_DIR}/fwfetcher.py" "../audios.bin"
      DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/fwfetcher.py")
  install (FILES "${CMAKE_CURRENT_BINARY_DIR}/../audios.bin" DESTINATION "${CMAKE_INSTALL_PREFIX}/share/libfreenect")
ENDIF()

LIST(APPEND SRC core.c tilt.c cameras.c flags.c usb_libusb10.c registration.c audio.c loader.c)

add_library (freenect SHARED ${SRC})
set_target_properties ( freenect PROPERTIES
  VERSION ${PROJECT_VER}
  SOVERSION ${PROJECT_APIVER})	
install (TARGETS freenect
  DESTINATION "${PROJECT_LIBRARY_INSTALL_DIR}")

add_library (freenectstatic STATIC ${SRC})
set_target_properties (freenectstatic PROPERTIES OUTPUT_NAME freenect)
IF(UNIX AND NOT APPLE)
  SET_TARGET_PROPERTIES (freenectstatic PROPERTIES COMPILE_FLAGS "-fPIC")
ENDIF()
install (TARGETS freenectstatic
  DESTINATION "${PROJECT_LIBRARY_INSTALL_DIR}")

target_link_libraries (freenect ${LIBUSB_1_LIBRARIES})
target_link_libraries (freenectstatic ${LIBUSB_1_LIBRARIES})

# Install the header files
install (FILES "../include/libfreenect.h" "../include/libfreenect_registration.h" "../include/libfreenect_audio.h"
  DESTINATION ${PROJECT_INCLUDE_INSTALL_DIR})

IF(UNIX)
  # Produce a pkg-config file for linking against the shared lib
  configure_file ("libfreenect.pc.in" "libfreenect.pc" @ONLY)
  install (FILES "${CMAKE_CURRENT_BINARY_DIR}/libfreenect.pc"
    DESTINATION "${PROJECT_LIBRARY_INSTALL_DIR}/pkgconfig")
ENDIF()

=== wrappers/actionscript/CMakeLists.txt ===
######################################################################################
# ActionScript socket server builder
######################################################################################

find_package(JPEG REQUIRED)

include_directories(${JPEG_INCLUDE_DIR})

add_library (as3_jpeg server/as3_jpeg.c)
target_link_libraries (as3_jpeg ${JPEG_LIBRARIES})

add_library (freenect_network server/freenect_network.c)

if (WIN32)
  set_source_files_properties(server/as3-server.c PROPERTIES LANGUAGE CXX)

  set(THREADS_USE_PTHREADS_WIN32 true)
  find_package(Threads REQUIRED)

  include_directories(${THREADS_PTHREADS_INCLUDE_DIR})
endif()

add_executable(as3-server server/as3-server.c)
if(APPLE)
	set(CMAKE_EXE_LINKER_FLAGS "-framework CoreFoundation -framework IOKit")
else(APPLE)
	find_package(Threads REQUIRED)
endif()
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../../wrappers/c_sync)

target_link_libraries(as3-server freenect_sync_static as3_jpeg freenect_network ${MATH_LIB} ${CMAKE_THREAD_LIBS_INIT})

=== wrappers/c_sync/CMakeLists.txt ===
######################################################################################
# C Synchronous Interface
######################################################################################

set(THREADS_USE_PTHREADS_WIN32 true)
find_package(Threads REQUIRED)
include_directories(${THREADS_PTHREADS_INCLUDE_DIR})

add_library (freenect_sync SHARED libfreenect_sync.c)
add_library (freenect_sync_static STATIC libfreenect_sync.c)
set_target_properties (freenect_sync_static PROPERTIES OUTPUT_NAME freenect_sync)

set_target_properties (freenect_sync PROPERTIES
  VERSION ${PROJECT_VER}
  SOVERSION ${PROJECT_APIVER})

target_link_libraries (freenect_sync freenect ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries (freenect_sync_static freenect ${CMAKE_THREAD_LIBS_INIT})

install (TARGETS freenect_sync
  DESTINATION "${PROJECT_LIBRARY_INSTALL_DIR}")
install (TARGETS freenect_sync_static
  DESTINATION "${PROJECT_LIBRARY_INSTALL_DIR}")
install (FILES "libfreenect_sync.h"
  DESTINATION ${PROJECT_INCLUDE_INSTALL_DIR})

=== wrappers/cpp/CMakeLists.txt ===
install(FILES libfreenect.hpp
        DESTINATION ${PROJECT_INCLUDE_INSTALL_DIR})

if (BUILD_EXAMPLES)
  set(THREADS_USE_PTHREADS_WIN32 true)
  find_package(Threads REQUIRED)
  find_package(OpenGL REQUIRED)
  find_package(GLUT REQUIRED)

  include_directories(. ${THREADS_PTHREADS_INCLUDE_DIR} ${OPENGL_INCLUDE_DIR} ${GLUT_INCLUDE_DIR})

  add_executable(freenect-cppview cppview.cpp)
  add_executable(freenect-cpp_pcview cpp_pc_view.cpp)

  target_link_libraries(freenect-cppview freenect ${OPENGL_LIBRARIES} ${GLUT_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIB})
  target_link_libraries(freenect-cpp_pcview freenect ${OPENGL_LIBRARIES} ${GLUT_LIBRARY} ${CMAKE_THREAD_LIBS_INIT} ${MATH_LIB})

  install(TARGETS freenect-cppview freenect-cpp_pcview
          DESTINATION bin)
ENDIF()

=== wrappers/java/Makefile ===
all:
	mvn assembly:assembly -Dmaven.test.skip=true

=== wrappers/opencv/CMakeLists.txt ===
######################################################################################
# OpenCV Interface
######################################################################################
find_package(OpenCV REQUIRED)
add_library (freenect_cv SHARED libfreenect_cv.c)
set_target_properties (freenect_cv PROPERTIES
  VERSION ${PROJECT_VER}
  SOVERSION ${PROJECT_APIVER})

include_directories (../c_sync)

target_link_libraries (freenect_cv freenect_sync ${OpenCV_LIBS})

install (TARGETS freenect_cv
  DESTINATION "${PROJECT_LIBRARY_INSTALL_DIR}")
install (FILES "libfreenect_cv.h"
  DESTINATION ${PROJECT_INCLUDE_INSTALL_DIR})

add_executable(freenect-cvdemo cvdemo.c)
target_link_libraries(freenect-cvdemo freenect freenect_sync freenect_cv ${OpenCV_LIBS})
install (TARGETS freenect-cvdemo
  DESTINATION bin)

=== wrappers/python/CMakeLists.txt ===
######################################################################################
# Python extension builder
######################################################################################

include(FindPythonInterp)
include(FindPythonLibs)

find_program(CYTHON_EXECUTABLE cython)

# Figure out installation path
execute_process(COMMAND
  ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(prefix='${CMAKE_INSTALL_PREFIX}')"
  OUTPUT_VARIABLE PYTHON_SITE_PACKAGES OUTPUT_STRIP_TRAILING_WHITESPACE)

# Figure out numpy include path
execute_process(COMMAND
  ${PYTHON_EXECUTABLE} -c "import numpy; print numpy.get_include()"
  OUTPUT_VARIABLE NUMPY_INCLUDE_PATH OUTPUT_STRIP_TRAILING_WHITESPACE)

# How to Cython the .pyx file
add_custom_command(OUTPUT freenect.c
  COMMAND ${CYTHON_EXECUTABLE} -o freenect.c "${CMAKE_CURRENT_SOURCE_DIR}/freenect.pyx")
list(APPEND ADDITIONAL_MAKE_CLEAN_FILES freenect.c)

# Compile the extension
add_library(cython_freenect MODULE freenect.c)
set_target_properties(cython_freenect PROPERTIES
  PREFIX ""
  OUTPUT_NAME "freenect"
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(cython_freenect freenect_sync ${PYTHON_LIBRARIES})
include_directories(${PYTHON_INCLUDE_PATH} ../c_sync/ ${NUMPY_INCLUDE_PATH})

# Install the extension
install(TARGETS cython_freenect
  DESTINATION ${PYTHON_SITE_PACKAGES})

# TODO: decide on what to do with demo_ scripts and were to install
#       them

=== debian/changelog ===
libfreenect (1:0.5.3-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113152)

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Oct 2025 13:52:30 +0200

libfreenect (1:0.5.3-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062298

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 12:05:12 +0000

libfreenect (1:0.5.3-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Move udev files from /lib to /usr/lib, including protective diversion
    against Multi-Arch: same file loss scenario (DEP17 P7 M10).
    (Closes: #1056911)

 -- Chris Hofstaedtler <zeha@debian.org>  Sun, 26 Nov 2023 15:57:36 +0100

libfreenect (1:0.5.3-3) unstable; urgency=medium

  * debian/control
    - fix up Vcs fields to point to salsa
    - remove no longer used X-Python-Version
    - remove libxmu-dev, libxi-dev from build-depends and move doxygen
      to -Indep. Thanks Helmut Grohne (Closes: #981416)
  * debian/patches/deb_glview
    - hardcode   set(GLUT_LIBRARY glut)  since otherwise not set nowadays
      (Closes: #1017176)
  * removed debian/patches/neurodebian-backport* (probably no longer needed,
    was from 2012). (Closes: #915921)

 -- Yaroslav Halchenko <debian@onerussian.com>  Tue, 13 Sep 2022 12:30:00 -0400

libfreenect (1:0.5.3-2) unstable; urgency=medium

  * Team upload.
  * Drop python2 support; python bindings can be added again when packaging an
    upstream release supporting python3; Closes: #936857

 -- Sandro Tosi <morph@debian.org>  Thu, 09 Apr 2020 00:50:52 -0400

libfreenect (1:0.5.3-1) unstable; urgency=medium

  * Recent upstream bugfix release
  * debian/{patches/deb_python_versions,rules}
    - adjusted to not use generic FindPython* helpers since shown to be
      not robust and in our case we need just a single version ATM
      (Closes: #809582)
  * debian/patches/up_donot_leak_fnusb_claim_camera_into_API
    to avoid leaking fnusb_claim_camera() into public library

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 01 Jan 2016 22:26:32 -0500

=== debian/control ===
Source: libfreenect
Section: libdevel
Priority: extra
Maintainer: Nicolas Bourdaud <nicolas.bourdaud@gmail.com>
Uploaders: Arne Bernin <arne@alamut.de>, Yaroslav Halchenko <debian@onerussian.com>, Mark Renouf <mark.renouf@gmail.com>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 9), cmake,  pkg-config,
 libusb-1.0-0-dev(>= 1.0.18~), freeglut3-dev,
Build-Depends-Indep:
 doxygen,
Standards-Version: 3.9.6
Homepage: http://openkinect.org/
Vcs-Git: https://salsa.debian.org/neurodebian-team/libfreenect.git -b debian
Vcs-Browser: https://salsa.debian.org/neurodebian-team/libfreenect.git

Package: libfreenect0.5t64
Provides: ${t64:Provides}
Replaces: libfreenect0.5
Breaks: libfreenect0.5 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libfreenect
Description: library for accessing Kinect device
 libfreenect is a cross-platform library that provides the necessary interfaces
 to activate, initialize, and communicate data with the Kinect hardware.
 Currently, the library supports access to RGB and depth video streams, motors,
 accelerometer and LED and provide binding in different languages (C++,
 Python...)
 .
 This library is the low level component of the OpenKinect project which is an
 open community of people interested in making use of the Xbox Kinect hardware
 with PCs and other devices.
 .
 This package contains the shared library of libfreenect.

Package: libfreenect-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libfreenect0.5t64 (= ${binary:Version}), libusb-1.0-0-dev (>= 1.0.18~)
Description: library for accessing Kinect device -- development files
 libfreenect is a cross-platform library that provides the necessary interfaces
 to activate, initialize, and communicate data with the Kinect hardware.
 Currently, the library supports access to RGB and depth video streams, motors,
 accelerometer and LED and provide binding in different languages (C++,
 Python...)
 .
 This library is the low level component of the OpenKinect project which is an
 open community of people interested in making use of the Xbox Kinect hardware
 with PCs and other devices.
 .
 This is the development package containing the libraries and header for
 software development with libfreenect.

Package: libfreenect-bin
Section: utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libfreenect-demos (<< 1:0.1.2+dfsg-1)
Breaks: libfreenect-demos (<< 1:0.1.2+dfsg-1)
Description: library for accessing Kinect device -- utilities and samples
 libfreenect is a cross-platform library that provides the necessary interfaces
 to activate, initialize, and communicate data with the Kinect hardware.
 Currently, the library supports access to RGB and depth video streams, motors,
 accelerometer and LED and provide binding in different languages (C++,
 Python...)
 .
 This library is the low level component of the OpenKinect project which is an
 open community of people interested in making use of the Xbox Kinect hardware
 with PCs and other devices.
 .
 This package includes utilities and sample programs for kinect.

Package: libfreenect-demos
Architecture: any
Depends: libfreenect-bin, ${misc:Depends}
Description: library for accessing Kinect device -- dummy package
 libfreenect is a cross-platform library that provides the necessary interfaces
 to activate, initialize, and communicate data with the Kinect hardware.
 Currently, the library supports access to RGB and depth video streams, motors,
 accelerometer and LED and provide binding in different languages (C++,
 Python...)
 .
 This library is the low level component of the OpenKinect project which is an
 open community of people interested in making use of the Xbox Kinect hardware
 with PCs and other devices.
 .
 This package is a metapackage to do the transition from libfreenect-demos
 to libfreenect-bin. This package can be removed after installation.

Package: libfreenect-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: library for accessing Kinect device -- documentation
 libfreenect is a cross-platform library that provides the necessary interfaces
 to activate, initialize, and communicate data with the Kinect hardware.
 Currently, the library supports access to RGB and depth video streams, motors,
 accelerometer and LED and provide binding in different languages (C++,
 Python...)
 .
 This library is the low level component of the OpenKinect project which is an
 open community of people interested in making use of the Xbox Kinect hardware
 with PCs and other devices.
 .
 This package contains the documentation of the API of libfreenect.

Package: freenect
Section: libs
Architecture: any
Depends: ${misc:Depends}, libfreenect-bin, libfreenect-dev, libfreenect0.5t64,
 libfreenect-doc
Description: library for accessing Kinect device -- metapackage
 libfreenect is a cross-platform library that provides the necessary interfaces
 to activate, initialize, and communicate data with the Kinect hardware.
 Currently, the library supports access to RGB and depth video streams, motors,
 accelerometer and LED and provide binding in different languages (C++,
 Python...)
 .
 This library is the low level component of the OpenKinect project which is an
 open community of people interested in making use of the Xbox Kinect hardware
 with PCs and other devices.
 .
 This is the metapackage to install all components of the project.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_LDFLAGS_MAINT_APPEND=-Wl,-Bsymbolic-functions -Wl,--as-needed
export MA_TRIPLET=`dpkg-architecture -qDEB_HOST_MULTIARCH`

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
      -DPROJECT_LIBRARY_INSTALL_DIR:Path="lib/$(MA_TRIPLET)"

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	doxygen debian/doxygen.conf
else
	: # Documentation was not built due to nodoc flag in DEB_BUILD_OPTIONS
	: # Creating dummy blank debian/html expected by -doc package
	mkdir -p debian/html
endif

override_dh_installdocs:
	dh_installdocs --all CONTRIB

override_dh_installudev:
	dh_installudev
	set -e; if test -d debian/libfreenect0.5/lib/udev/rules.d; then mv debian/libfreenect0.5/lib/udev debian/libfreenect0.5/usr/lib; fi
	set -e; if test -d debian/libfreenect0.5/lib; then rmdir debian/libfreenect0.5/lib; fi

override_dh_makeshlibs:
	dh_makeshlibs -Xfakenect

override_dh_clean-indep:
	rm -rf debian/html

=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg//" \
  https://github.com/OpenKinect/libfreenect/tags .*/archive/v(\d[\d\.]+).tar.gz
